/*************************
* STLt@Cǂݍ  *
**************************/

#include "STL_Parser.h"

// *body --- ̂\GeBeB̏WIuWFNgւ̃|C^
// TypeNum[] --- eGeBeB̐i[
int STL_PARSER::STL_Parser_Main(BODY *body,char STL_fname[])
{
	FILE *fp;
	NURBS_Func nfunc;
	char buf[BUFSIZEMAX];		// ꎞi[pobt@
	char label[LABELSIZEMAX];	// xꎞi[pobt@
	char mes[BUFSIZEMAX];		// o͗pbZ[Wi[obt@
	int facet_num=0;			// t@Zbg̑
	double maxval = -1.0E+6;	// Wl̍őli[

	// t@ZbgNURBSŕ\邽߂̊ep[^Zbg
	int K[2] = {2,2};							// Rg[|Cg̐2
	int N[2] = {4,4};							// mbgxNg̐4
	int M[2] = {2,2};							// K2
	double U[2] = {0,1};						// ũmbgxNg̊JnlƏIl
	double V[2] = {0,1};						// vmbgxNg̊JnlƏIl
	Vector S = NewVector(N[0]);					// ũmbgxNg
	Vector T = NewVector(N[1]);					// vmbgxNg
	Matrix W = NewMatrix(K[0],K[1]);			// EGCg
	Coord **facet = NewCoord2(2,2);				// Rg[|Cg
	S[0] = S[1] = T[0] = T[1] = 0;				// ũmbgxNg͕ʂȂ̂ŊɌ܂Ă
	S[2] = S[3] = T[2] = T[3] = 1;				// vmbgxNg͕ʂȂ̂ŊɌ܂Ă
	W[0][0] = W[0][1] = W[1][0] = W[1][1] = 1;	// EGCg͕ʂȂ̂ŊɌ܂Ă

	// STLt@CI[v
	if((fp = fopen(STL_fname,"r")) == NULL){
		sprintf(mes,"KOD_ERROR: Cannot open %s",STL_fname);
		SetMessage(mes);
		return(KOD_ERR);
	}
	sprintf(mes,"Open %s",STL_fname);
	SetMessage(mes);

	// ܂t@Zbg̑𐔂
	while(fgets(buf,sizeof(buf),fp) != NULL){
		sscanf(buf,"%s",label);							// xo
		if(!strncmp(label,"facet",LABEL_FASET_SIZE))	// x"facet"Ȃ
			facet_num++;								// t@ZbgCNg
	}
	sprintf(mes,"Total facet number is %d.",facet_num);
	SetMessage(mes);

	fseek(fp,0L,SEEK_SET);		// t@C擪ɖ߂

	body->NurbsS = (NURBSS *)malloc(sizeof(NURBSS) * facet_num);	// t@ZbgNURBSȖʂ[m
	body->TypeNum[_NURBSS] = facet_num;

	// Wlǂݍ
	int j=0;
	while(fgets(buf,sizeof(buf),fp) != NULL){
		sscanf(buf,"%s",label);
		if(!strncmp(label,"outer",LABEL_OUTER_SIZE)){
			int m=0,n=0;
			for(int i=0;i<VERTEXNUM;i++){	// t@Zbg_Wǂݍ
				fgets(buf,sizeof(buf),fp);
				sscanf(buf,"%s %lf %lf %lf",label,&facet[m][n].x,&facet[m][n].y,&facet[m][n].z);
				double d = CalcEuclid(facet[m][n]);
				if(maxval < d) maxval = d;			// \pɍW̍ől𒲂ׂ
				n++;
				if(n == UVCPNUM){
					n=0;
					m++;
				}
			}
			// NURBSȖʂŕʂ\ꍇA_4KvAOppb`̏ꍇ3_Ȃ߁A_ǉȂ΂ȂȂB
			// Ƃ肠Oppb`3_ڂƓWl4_ڂƂĂ݂B--> \B
			facet[UVCPNUM-1][UVCPNUM-1] = SetCoord(facet[UVCPNUM-1][0]);
			nfunc.GenNurbsS(&body->NurbsS[j],M[0],M[1],K[0],K[1],S,T,W,facet,U[0],U[1],V[0],V[1]);			// NURBSt@Zbg
			body->NurbsS[j].TrmdSurfFlag = KOD_FALSE;							// ĝȂPNURBSȖʂł邱Ƃ𖾎
			body->ChangeStatColor(body->NurbsS[j].Dstat.Color,0.2,0.2,1,0.5);		// FɃZbg
			j++;
		}
	}

	body->MaxCoord = maxval;	// őWlo^
			
	FreeVector(S);
	FreeVector(T);
	FreeMatrix(W,K[0]);
	FreeCoord2(facet,UVCPNUM);

	fclose(fp);

	return KOD_TRUE;
}