#ifndef _STD_AFX_H_
#define _STD_AFX_H_

 #define USE_WIDE_STUDIO	

// R[obNɊւWindowsUNIX̌݊ۂ}N
#ifdef _MSC_VER
#ifndef CALLBACK
#define CALLBACK __stdcall
#endif
#define EXPORT extern "C" __declspec(dllexport)
#else
#ifndef CALLBACK
#define	CALLBACK
#endif
#define EXPORT extern "C"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

// GLUTwb_t@C̃CN[h
// eOSɍ킹ēK؂GLUT.h̃t@Cʒuw肵Ă
#ifndef MacOS
#include <GL/glut.h>
#else
#include <GLUT/glut.h>
#endif

#ifdef USE_WIDE_STUDIO
#include "StdAfxWS.h"
#else
#include "StdAfx__.h"
#endif

#define KOD_ERR	-1					// ERROR̃V{
#define KOD_FALSE	0				// ŨV{
#define KOD_TRUE	1				// ^̃V{
#define KOD_DONE	2				// sς݂V{
#define KOD_ONEDGE	2				// _GbWɂ邱ƂV{
#define KOD_EQUAL	2				// l̃V{
#define LOW_ACCURACY  0				// ᐸx̃V{
#define MID_ACCURACY  1				// ʐx̃V{
#define HIGH_ACCURACY 2				// x̃V{
#define FNAMEMAX	256				// t@C̍ő啶
#define PI 3.141592653589793		// ~
#define APPROX_ZERO_L 1.0e-6		// [ƌȂl(ᐸx)
#define APPROX_ZERO	1.0e-12			// [ƌȂl(ʐx)
#define APPROX_ZERO_H 1.0e-16		// [ƌȂl(x)
#define LOOPCOUNTMAX	100			// vZ񐔂̏
#define COORDINDEX 3				// 3WCfbNX
#define QUADINDEX 4					// 3WCfbNX


typedef double **Matrix;	// double`2zMatrixƂĒ`
typedef double *Vector;		// double`1zVectorƂĒ`

// Wp\̂`
//typedef struct{
//	double x,y,z;	// x,y,zWl
//	double dmy;		// ėp
//}Coord;

// WlpNX`
class Coord
{
public:

	double x,y,z;	// x,y,zWl
	double dmy;		// ėp

	// Iy[^̃I[o[[h
	Coord operator +(Coord);	// Wlm̑Z(AddCoord())
	Coord operator -(Coord);	// Wlm̈Z(SubCoord())
	Coord operator *(Coord);	// Wlm̊|Z(MulCoord())
	Coord operator *(double);	// I[o[[h
	Coord operator /(Coord);	// Wlm̊Z(DivCoord())
	Coord operator /(double);	// I[o[[h
	double operator &(Coord);	// Wlm̓(CalcInnerProduct())
	Coord operator &&(Coord);	// Wlm̊O(CalcOuterProduct())
};

// ϊsp\
typedef struct{
	Coord Rot[COORDINDEX];		// ]s
	Coord Trl;					// i
}FRAME;

// \p\
typedef struct{
	float Color[4];	// F(r,g,b,?)
	// \̒ǉ͂ɋLq
}DispStat;

// O[oȊ֐̒` ///////////////////////////////////////////////////////////////////////////

//  2,3xNgZ
void InitCoord(Coord *);						// Wl̏
void InitCoord(Coord *,int);					// I[o[[h
Coord InitCoord();								// I[o[[h
Coord AddCoord(Coord,Coord);					// Wl̑Z
Coord AddCoord(Coord,double);					// I[o[[h
Coord AddCoord(Coord,double,double,double);		// I[o[[h
Coord DivCoord(Coord,Coord);					// Wl̊Z
Coord DivCoord(Coord,double);					// I[o[[h
Coord DivCoord(Coord,double,double,double);		// I[o[[h
Coord MulCoord(Coord,Coord);					// Wl̊|Z(xNg̓,Oςł͂Ȃ̂Œ)
Coord MulCoord(Coord,double);					// I[o[[h
Coord MulCoord(Coord,double,double,double);		// I[o[[h
Coord SubCoord(Coord,Coord);					// Wl̈Z
Coord SubCoord(Coord,double);					// I[o[[h
Coord SubCoord(Coord,double,double,double);		// I[o[[h
Coord SetCoord(Coord);							// Wl
Coord SetCoord(double,double,double);			// I[o[[h
void CopyCoord(Coord *,int,Coord *);			// WlQRs[
int DiffCoord(Coord,Coord);						// WlȂKOD_TRUEAقȂĂȂKOD_FALSEԂ
int DiffCoord(Coord,Coord,double);				// I[o[[h(xw)
Coord AbsCoord(Coord);							// Wl̐ΒlԂ
int ZoroCoord(Coord);							// (0,0,0)̏ꍇKOD_TRUEԂ
double CalcEuclid(Coord);						// [NbhƂ߂
Coord NormalizeVec(Coord);						// 3xNg𐳋K(PʃxNg)
Coord NormalizeVec(double,double,double);		// I[o[[h
double CalcDistance(Coord,Coord);				// 2_Ԃ̃[Nbh߂
double CalcInnerProduct(Coord,Coord);			// ς߂
double CalcInnerProduct(Coord,double,double,double);	// I[o[[h
Coord CalcOuterProduct(Coord,Coord);			// Oς߂
Coord CalcInterDivPt(Coord,Coord,double);		// 2_Ԃ̓_߂
Coord CalcOrthoProjection(Coord,Coord,Coord);	// Cӂ̓_Cӂ̕ʂ֐ˉe
double CalcDistPtToPlane(Coord,Coord,Coord);	// Cӂ̓_Cӂ̕ʂ܂ł̋߂
double CalcScalarTriProduct(Coord,Coord,Coord);	// XJ[Odς߂
Coord CalcRotVec(Coord,Coord,double);			// Cӂ̃xNg_ʂCӎɉ]xNg߂(3D)
double CalcVecAngle(Coord,Coord);				// 2̃xNĝȂp߂
Coord CalcNormalLine(Coord,Coord,Coord);		// Cӂ̓_Cӂ̒։낵_߂
Coord Arc_CP(Coord,Coord,double);				// ~̒S_(vec[0])~ɐڂCӂ2{̐ڐ_ւ̃xNg(Sp0<<)
int IsPointInPolygon(Coord,Coord *,int);		// ړ_̑p`O
Coord CalcNormVecFrom3Pts(Coord,Coord,Coord);	// ԏ3_Ȃ镽ʂ̖@xNg߂

Coord AddCoord2D(Coord,Coord);					// Wl̑Z (2D Ver.)
Coord AddCoord2D(Coord,double);					// I[o[[h (2D Ver.)
Coord AddCoord2D(Coord,double,double);			// I[o[[h (2D Ver.)
Coord DivCoord2D(Coord,Coord);					// Wl̊Z (2D Ver.)
Coord DivCoord2D(Coord,double);					// I[o[[h (2D Ver.)
Coord DivCoord2D(Coord,double,double);			// I[o[[h (2D Ver.)
Coord MulCoord2D(Coord,Coord);					// Wl̊|Z(xNg̓,Oςł͂Ȃ̂Œ) (2D Ver.)
Coord MulCoord2D(Coord,double);					// I[o[[h (2D Ver.)
Coord MulCoord2D(Coord,double,double);			// I[o[[h (2D Ver.)
Coord SubCoord2D(Coord,Coord);					// Wl̈Z (2D Ver.)
Coord SubCoord2D(Coord,double);					// I[o[[h (2D Ver.)
Coord SubCoord2D(Coord,double,double);			// I[o[[h (2D Ver.)
Coord SetCoord2D(Coord);						// Wl (2D Ver.)
Coord SetCoord2D(double,double);				// I[o[[h (2D Ver.)
void CopyCoord2D(Coord *,int,Coord *);			// WlQRs[ (2D Ver.)
int DiffCoord2D(Coord,Coord);					// WlȂKOD_TRUEAقȂĂȂKOD_FALSEԂ (2D Ver.)
int DiffCoord2D(Coord,Coord,double);			// I[o[[h(xw) (2D Ver.)
Coord AbsCoord2D(Coord);						// Wl̐ΒlԂ (2D Ver.)
int ZoroCoord2D(Coord);							// (0,0,0)̏ꍇKOD_TRUEԂ (2D Ver.)
double CalcEuclid2D(double,double);				// [NbhƂ߂ (2D Ver.)
double CalcDistance2D(Coord,Coord);				// 2Wł2_Ԃ̃[NbhZo (2D Ver.)
double CalcVecAngle2D(Coord,Coord);				// 2̃xNĝȂp߂ (2D Ver.)
Coord CalcRotVec2D(Coord,double);				// Cӂ̃xNg]xNg߂(2D)
double CalcOuterProduct2D(Coord,Coord);			// Oς߂ (2D Ver.)
double ClacPolygonArea2D(Coord [],int);			// 2Dʏ̑p`̕tʐς𓾂
int DiscriminateCW2D(Coord [],int);				// 2Dʏ̑p`v肩v肩𔻕ʂ


// ϊsA]s̉Z
Coord MulFrameCoord(double[][3],double[],Coord);	// ϊsƍWl(3DxNg)Ƃ̊|Z
Coord MulFrameCoord(FRAME,Coord);				// I[o[[h 
FRAME MulFrame(FRAME ,FRAME);					// ϊs̊|Z
FRAME InvFrame(FRAME);							// ϊs̋ts𓾂
Coord RotToZYZEuler(Coord []);					// ]sZYZIC[p֕ϊ
void InitFrame(FRAME *);						// FRAMȄ

// xNgAs̉Z
void InitVector(Vector,int);					// 1z̏(:xNg,z)
void InitMatrix(Matrix,int,int);				// 2z̏
void CopyVector(Vector,int,Vector);				// xNg̃Rs[
void AddMxMx(Matrix,Matrix,Matrix,int,int);		// s񓯎m̑Z
void MulMxMx(Matrix,int,int,Matrix,int,int,Matrix);	// s񓯎m̊|Z
void MulMxVec(Matrix,int,int,Vector,int,Vector);	// sƃxNg̊|Z
void MulMxVec(Matrix,int,int,Coord *,Coord *);	// sƍWlxNg̊|Z
Coord MulMxCoord(Coord [],Coord);				// Coordŕ\3x3sCoordxNgƂ̊|Z
Coord MulMxCoord(Matrix,Coord);					// 3x3sCoordxNgƂ̊|Z
void TranMx(Matrix,int,int,Matrix);				// ]us𓾂
void TranMx(Coord **,int,int,Coord **);			// ]us𓾂(I[o[[h)
void TranMx(Coord [],Coord []);					// ]us𓾂(I[o[[h)
double Gauss(int,Matrix,Vector,Vector);			// A1̉߂
double Gauss(int,Matrix,Coord *,Coord *);		// A1̉߂(I[o[[h)
void LU_Solver(int,Matrix,Vector,int *,Vector);	// LǓʂA1
void LU_Solver(int,Matrix,Coord *,int *,Coord *);// LǓʂA1(I[o[[h)
double LU(int,Matrix,int *);					// LU
double MatInv(int,Matrix,Matrix);				// ts߂
double MatInv3(Matrix,Matrix);					// 3x3̋ts
double MatInv2(Matrix,Matrix);					// 2x2̋ts

// lvZ
double DegToRad(double degree);					// pxPʂdegreeradian
double RadToDeg(double radian);					// pxPʂradiandegree
int CalcCubicEquation(double *,double *);		// 3̉߂
int CalcQuadraticEquation(double *,double *);	// 2̉߂
int CalcLinearEquation(double *,double *);		// 1̉߂
int nCr(int n,int r);							// 2W(nCȓg)߂
int Factorial(int n);							// Rn̊K߂

// `֘A
void DrawPoint(Coord,double,double,double []);			// _`
void DrawPoints(Coord *,int,double,double,double []);	// _Q`
void DrawVector(Coord,Coord,double,double,double []);	// xNg`
void DrawLine(Coord,Coord,double,double []);			// 2_Ԃɐ`
void SetColorStat(DispStat *ds,float r, float g, float b, float a=0.5);	// J[Xe[^XύX


// [֘A
Matrix NewMatrix(int,int);			// 2double^z̃[m
Vector NewVector(int);				// 1double^z̃[m
void FreeMatrix(Matrix,int);		// 2double^z̃[
void FreeVector(Vector);			// 1double^z̃[
Coord *NewCoord1(int);				// 1Coord^z̃[m
void FreeCoord1(Coord *);			// 1Coord^z̃[
Coord **NewCoord2(int,int);			// 2Coord^z̃[m
void FreeCoord2(Coord **,int);		// 2Coord^z̃[

// ̑
double sgn(double);						// 
int CheckZero(double,int);				// lAPPROX_ZERO͈̔͂0ł邩`FbN
int CheckRange(double,double,double,int);	// w肵lw肵͈͓ł邩`FbN
int CheckMag(double,double,int);		// 2̒l̑召r 
void BubbleSort(int[],int);				// ou\[g({@)
void BubbleSort(double[],int);			// I[o[[h
int QCmp(const void *,const void *);	// NCbN\[g 
void Reverse(Coord [],int);				// Coordz̔]
void Reverse(double [],int);			// doublez̔]

#endif
