#include "BODY.h"

// RXgN^
BODY::BODY()
{
	// 
	for(int i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		TypeNum[i] = 0;
	}
	Mesh = NULL;
	Mom = NULL;

	MaxCoord = 1;
}

// BODYNX̃[m
void BODY::NewBodyElem()
{
	int flag=0;

	// GeBeBVɒǉꍇ͈ȉɐVmallocLqĂB
	// GeBeB^Cv̔ԍႢɋLq
	if(TypeNum[_CIRCLE_ARC]){
		if((CirA = (CIRA *)malloc(sizeof(CIRA)*TypeNum[_CIRCLE_ARC])) == NULL)  goto EXIT;
		flag = _CIRCLE_ARC+1;
	}

	if(TypeNum[_COMPOSITE_CURVE]){
		if((CompC = (COMPC *)malloc(sizeof(COMPC)*TypeNum[_COMPOSITE_CURVE])) == NULL)  goto EXIT;
		flag = _COMPOSITE_CURVE+1;
	}

	if(TypeNum[_CONIC_ARC]){
		if((ConA = (CONA *)malloc(sizeof(CONA)*TypeNum[_CONIC_ARC])) == NULL)  goto EXIT;
		flag = _CONIC_ARC+1;
	}

	if(TypeNum[_LINE]){
		if((Line = (LINE_ *)malloc(sizeof(LINE_)*TypeNum[_LINE])) == NULL)  goto EXIT;
		flag = _LINE+1;
	}

	if(TypeNum[_TRANSFORMATION_MATRIX]){
		if((TMat = (TMAT *)malloc(sizeof(TMAT)*TypeNum[_TRANSFORMATION_MATRIX])) == NULL)  goto EXIT;
		flag = _TRANSFORMATION_MATRIX+1;
	}

	if(TypeNum[_NURBSC]){
		if((NurbsC = (NURBSC *)malloc(sizeof(NURBSC)*TypeNum[_NURBSC])) == NULL)  goto EXIT;
		flag = _NURBSC+1;
	}

	if(TypeNum[_NURBSS]){
		if((NurbsS = (NURBSS *)malloc(sizeof(NURBSS)*TypeNum[_NURBSS])) == NULL)  goto EXIT;
		flag = _NURBSS+1;
	}

	if(TypeNum[_CURVE_ON_PARAMETRIC_SURFACE]){
		if((ConpS = (CONPS *)malloc(sizeof(CONPS)*TypeNum[_CURVE_ON_PARAMETRIC_SURFACE])) == NULL)  goto EXIT;
		flag = _CURVE_ON_PARAMETRIC_SURFACE+1;
	}

	if(TypeNum[_TRIMMED_SURFACE]){
		if((TrmS = (TRMS *)malloc(sizeof(TRMS)*TypeNum[_TRIMMED_SURFACE])) == NULL)  goto EXIT;
		flag = _TRIMMED_SURFACE+1;
	}

	Mesh = NULL;		// bVNULLɐݒ肵Ă

	return;		// [𐳏Ɋm


EXIT:	// [mۂɎsꍇ́A܂ŊmۂďI
	SetMessage("KOD_ERROR: malloc BODY");
	while(flag){
		if(flag == _CURVE_ON_PARAMETRIC_SURFACE+1 && TypeNum[_TRIMMED_SURFACE]){
			free(ConpS);
		}
		else if(flag == _NURBSS+1 && TypeNum[_NURBSS]){
			free(NurbsS);
		}
		else if(flag == _NURBSC+1 && TypeNum[_NURBSC]){
			free(NurbsC);
		}
		else if(flag == _TRANSFORMATION_MATRIX+1 && TypeNum[_TRANSFORMATION_MATRIX]){
			free(TMat);
		}
		else if(flag == _LINE+1 && TypeNum[_LINE]){
			free(Line);
		}
		else if(flag == _CONIC_ARC+1 && TypeNum[_CONIC_ARC]){
			free(ConA);
		}
		else if(flag == _COMPOSITE_CURVE+1 && TypeNum[_COMPOSITE_CURVE]){
			free(CompC);
		}
		else if(flag == _CIRCLE_ARC+1 && TypeNum[_CIRCLE_ARC]){
			free(CirA);
		}
		flag--;
	}
	exit(KOD_ERR);
}

// BODY\SGeBeB̃J
void BODY::DelBodyElem()
{
	NURBS_Func NFunc;

	// GeBeBVɒǉꍇ͈ȉɐVfreeǉ
	if(TypeNum[_TRIMMED_SURFACE]){
		NFunc.Free_TrmS_1DArray(TrmS,TypeNum[_TRIMMED_SURFACE]);
		free(TrmS);
	}
	if(TypeNum[_CURVE_ON_PARAMETRIC_SURFACE]){
		free(ConpS);
	}
	if(TypeNum[_NURBSS]){
		NFunc.Free_NurbsS_1DArray(NurbsS,TypeNum[_NURBSS]);
		free(NurbsS);
	}
	if(TypeNum[_NURBSC]){
		NFunc.Free_NurbsC_1DArray(NurbsC,TypeNum[_NURBSC]);
		free(NurbsC);
	}
	if(TypeNum[_TRANSFORMATION_MATRIX]){
		free(TMat);
	}
	if(TypeNum[_LINE]){
		free(Line);
	}
	if(TypeNum[_CONIC_ARC]){
		free(ConA);
	}
	if(TypeNum[_COMPOSITE_CURVE]){
		NFunc.Free_CompC_1DArray(CompC,TypeNum[_COMPOSITE_CURVE]);
		free(CompC);
	}
	if(TypeNum[_CIRCLE_ARC]){
		free(CirA);
	}
	if(Mesh != NULL){
		Mesh->clear();
	}
}
// BODY\GeBeBw肵J
void BODY::DelBodyElem(int TypeNum_[])
{
	NURBS_Func NFunc;

	// GeBeBVɒǉꍇ͈ȉɐVfreeǉ
	if(TypeNum_[_TRIMMED_SURFACE]){
		NFunc.Free_TrmS_1DArray(TrmS,TypeNum_[_TRIMMED_SURFACE]);
		free(TrmS);
	}
	if(TypeNum_[_CURVE_ON_PARAMETRIC_SURFACE]){
		free(ConpS);
	}
	if(TypeNum_[_NURBSS]){
		NFunc.Free_NurbsS_1DArray(NurbsS,TypeNum_[_NURBSS]);
		free(NurbsS);
	}
	if(TypeNum_[_NURBSC]){
		NFunc.Free_NurbsC_1DArray(NurbsC,TypeNum_[_NURBSC]);
		free(NurbsC);
	}
	if(TypeNum_[_TRANSFORMATION_MATRIX]){
		free(TMat);
	}
	if(TypeNum_[_LINE]){
		free(Line);
	}
	if(TypeNum_[_CONIC_ARC]){
		free(ConA);
	}
	if(TypeNum_[_COMPOSITE_CURVE]){
		NFunc.Free_CompC_1DArray(CompC,TypeNum_[_COMPOSITE_CURVE]);
		free(CompC);
	}
	if(TypeNum_[_CIRCLE_ARC]){
		free(CirA);
	}
	if(Mesh != NULL){
		Mesh->clear();
	}
}

// BODỶ]
void BODY::RotBody(Coord Axis,double deg)
{
	NURBS_Func NFunc;

	for(int i=0;i<TypeNum[_NURBSS];i++)			// NURBSȖʂ̃Vtg
		NFunc.RotNurbsS(&NurbsS[i],Axis,deg);
	for(int i=0;i<TypeNum[_NURBSC];i++){			// NURBSȐ̃Vtg
		if(NurbsC[i].EntUseFlag == GEOMTRYELEM)	// NURBSȖʂ̃pgbNvfƂĂNURBSȐɊւĂ͉Ȃ
			NFunc.RotNurbsC(&NurbsC[i],Axis,deg);
	}
}

// BODỸVtg
void BODY::ShiftBody(Coord d)
{
	NURBS_Func NFunc;

	for(int i=0;i<TypeNum[_NURBSS];i++)			// NURBSȖʂ̃Vtg
		NFunc.ShiftNurbsS(&NurbsS[i],d);
	for(int i=0;i<TypeNum[_NURBSC];i++){		// NURBSȐ̃Vtg
		if(NurbsC[i].EntUseFlag == GEOMTRYELEM)	// NURBSȖʂ̃pgbNvfƂĂNURBSȐɊւĂ͉Ȃ
			NFunc.ShiftNurbsC(&NurbsC[i],d);
	}
}

// BODY̊gk
void BODY::ExpandBody(Coord r)
{
	NURBS_Func NFunc;

	for(int i=0;i<TypeNum[_NURBSS];i++)			// NURBSȖʂ̃Vtg
		NFunc.ChRatioNurbsS(&NurbsS[i],r);
	for(int i=0;i<TypeNum[_NURBSC];i++){		// NURBSȐ̃Vtg
		if(NurbsC[i].EntUseFlag == GEOMTRYELEM)	// NURBSȖʂ̃pgbNvfƂĂNURBSȐɊւĂ͉Ȃ
		NFunc.ChRatioNurbsC(&NurbsC[i],r);		// NURBSȐ̊g
	}
}

// VBODYƂēo^
void BODY::RegistBody(BODYList *BodyList, char BodyName[])
{
	Mom = BodyList->add(this);				// ǂݍIGESf[^BODYListɓo^
	strcpy(Name,BodyName);					// t@CbodyƂēo^
}

// g
void BODY::DeleteBody(BODYList *BodyList)
{
	BodyList->delData(Mom);			// XgǂݍBODY͂
	DelBodyElem();					// BODYŊmۂĂ郁[̉
}

// 1NURBSȐVBODYƂēo^
void BODY::RegistNurbsCtoBody(BODYList *BodyList,NURBSC Nurb,char BodyName[])
{
	NurbsC = (NURBSC *)malloc(sizeof(NURBSC));
	NurbsC[0] = Nurb;												// NURBSȖʂ̎̂
	TypeNum[_NURBSC] = 1;											// NURBSȖʂ̐1ɂ
	ChangeStatColor(this->NurbsC[0].Dstat.Color,0.2,0.2,1.0,0.5);		// F
	BodyList->add(this);										// XgɐVBODYo^
	//SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Name,BodyName);										// VBODYo^
}

// NNURBSȐVBODYƂēo^
void BODY::RegistNurbsCtoBodyN(BODYList *BodyList,NURBSC Nurb[],char BodyName[],int N)
{
	NurbsC = (NURBSC *)malloc(sizeof(NURBSC)*N);
	for(int i=0;i<N;i++){
		NurbsC[i] = Nurb[i];										// NURBSȖʂ̎̂
		TypeNum[_NURBSC] = N;										// NURBSȖʂ̐1ɂ
		ChangeStatColor(this->NurbsC[i].Dstat.Color,0.2,0.2,1.0,0.5);	// F
	}
	BodyList->add((void *)this);										// XgɐVBODYo^
	//SetBodyNameToWin(BodyName);											// BodyXgEBhEBODYo^
	strcpy(Name,BodyName);										// VBODYo^
}


// 1NURBSȖʂVBODYƂēo^
void BODY::RegistNurbsStoBody(BODYList *BodyList,NURBSS Nurb,char BodyName[])
{
	NurbsS = (NURBSS *)malloc(sizeof(NURBSS));
	NurbsS[0] = Nurb;												// NURBSȖʂ̎̂
	NurbsS[0].TrmdSurfFlag = KOD_FALSE;								// ĝȂPNURBSȖʂł邱Ƃ𖾎
	TypeNum[_NURBSS] = 1;											// NURBSȖʂ̐1ɂ
	ChangeStatColor(this->NurbsS[0].Dstat.Color,0.2,0.2,1.0,0.5);	// F
	this->Mom = BodyList->add((void *)this);						// XgɐVBODYo^
	//SetBodyNameToWin(BodyName);										// BodyXgEBhEBODYo^
	strcpy(Name,BodyName);											// VBODYo^
}

// NNURBSȖʂVBODYƂēo^
void BODY::RegistNurbsStoBodyN(BODYList *BodyList,NURBSS Nurb[],char BodyName[],int N)
{
	NurbsS = (NURBSS *)malloc(sizeof(NURBSS)*N);
	for(int i=0;i<N;i++){
		NurbsS[i] = Nurb[i];										// NURBSȖʂ̎̂
		NurbsS[i].TrmdSurfFlag = KOD_FALSE;							// ĝȂPNURBSȖʂł邱Ƃ𖾎
		TypeNum[_NURBSS] = N;										// NURBSȖʂ̐1ɂ
		ChangeStatColor(this->NurbsS[i].Dstat.Color,0.2,0.2,1.0,0.5);	// F
	}
	this->Mom = BodyList->add((void *)this);						// XgɐVBODYo^
	//SetBodyNameToWin(BodyName);										// BodyXgEBhEBODYo^
	strcpy(Name,BodyName);											// VBODYo^
}

// GeBeB̃Xe[^XŒ`ĂFύX
void BODY::ChangeStatColor(float *col,float r,float g,float b,float t)
{
	col[0] = r;
	col[1] = g;
	col[2] = b;
	col[3] = t;
}

// ̐F̏l^
void BODY::InitCurveColor(float *col)
{
	col[0] = col[1] = col[2] = 1.0;
	col[3] = 0.5;
}

// ʂ̐F̏l^
void BODY::InitSurfaceColor(float *col)
{
	col[0] = col[1] = col[2] = 0.2;
	col[3] = 0.5;
}
