/***************
* BODY`RA *
****************/

#include "Describe_BODY.h"

// RXgN^
Describe_BODY::Describe_BODY()
{
	SetNurbsStat();
}

// fXgN^
Describe_BODY::~Describe_BODY()
{
}

// Body`
void Describe_BODY::DrawBody(BODY *Body)
{
	for(int i=0;i<ALL_ENTITY_TYPE_NUM;i++){
		if(i == _CIRCLE_ARC){						// ~E~
			// ~E~ʂNRBSȐɕϊ
			//Draw_CircleArc();
		}
		else if(i == _CONIC_ARC){					// ~Ȑ
			//Draw_ConicArc();
		}
		else if(i == _LINE){						// 
			// NURBSȐɕϊ
			//Draw_Line();
		}
		else if(i == _NURBSC){						// NURBSȐ
			Draw_NurbsCurves(Body);
		}
		else if(i == _NURBSS){
			Draw_NurbsSurfaces(Body);
		}
		else if(i == _TRIMMED_SURFACE){				// g(NURBSȖ)
			Draw_TrimSurfes(Body);
		}
	}
}

// ̕`
void Describe_BODY::DrawLine(LINE_ Line)
{
	glLineWidth(1);

	glBegin(GL_LINE_STRIP);
	glVertex3d(Line.cp[0].x,Line.cp[0].y,Line.cp[0].z);	// n_
	glVertex3d(Line.cp[1].x,Line.cp[1].y,Line.cp[1].z);	// I_
	glEnd();

}

// NURBSȐ̕`
void Describe_BODY::DrawNurbsCurve(NURBSC NurbsC)
{
	int i,j;
	static GLfloat	uKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	CCtlp[CTLPNUMMAX][4];				// NURBS`pobt@

	for(i=0;i<NurbsC.K;i++){			// Rg[|Cgo
		CCtlp[i][0] = NurbsC.cp[i].x*NurbsC.W[i];
		CCtlp[i][1] = NurbsC.cp[i].y*NurbsC.W[i];
		CCtlp[i][2] = NurbsC.cp[i].z*NurbsC.W[i];
		CCtlp[i][3] = NurbsC.W[i];
	}

	for(j=0;j<NurbsC.N;j++){			// mbgxNgo
		uKnot[j] = NurbsC.T[j];
	}

	glDisable(GL_LIGHTING);
	gluBeginCurve(NurbsCurve);
	gluNurbsCurve(NurbsCurve,NurbsC.N,uKnot,4,&CCtlp[0][0],NurbsC.M,GL_MAP1_VERTEX_4);	// mbgxNg̒l͈̔͂0`1łȂƁA
	gluEndCurve(NurbsCurve);															// "mbgXvC߂葽܂Ɠ{"
	glFlush();																			// mbgxNg̐KKv(pp111)
	glEnable(GL_LIGHTING);

}


// NURBSȖʂ̕`(g)
void Describe_BODY::DrawTrimdNurbsSurfe(NURBSS *NurbsS)
{
	int j,k;
	static GLfloat	uKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	vKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	SCtlp[CTLPNUMMAX][CTLPNUMMAX][4];	// NURBS`pobt@

	//NURBS_Func NFunc;					// for debug
	//NFunc.DebugForNurbsS(NurbsS);		// for debug

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,NurbsS->Dstat.Color);
	for(k=0;k<NurbsS->K[1];k++){
		for(j=0;j<NurbsS->K[0];j++){
			SCtlp[j][k][0] = NurbsS->cp[j][k].x*NurbsS->W[j][k];	// Rg[|Cgo
			SCtlp[j][k][1] = NurbsS->cp[j][k].y*NurbsS->W[j][k];
			SCtlp[j][k][2] = NurbsS->cp[j][k].z*NurbsS->W[j][k];
			SCtlp[j][k][3] = NurbsS->W[j][k];
		}
	}
	for(j=0;j<NurbsS->N[0];j++){
		uKnot[j] = NurbsS->S[j];		// umbgxNgo
		//fprintf(stderr,"U:%d-%.12lf\n",j+1,uKnot[j]);
	}
	for(j=0;j<NurbsS->N[1];j++){
		vKnot[j] = NurbsS->T[j];		// vmbgxNgo
		//fprintf(stderr,"V:%d-%.12lf\n",j+1,vKnot[j]);
	}

	// NURBSȖʂ̕`
	gluNurbsSurface(NurbsSurf,(GLdouble)NurbsS->N[0],uKnot,(GLdouble)NurbsS->N[1],vKnot,CTLPNUMMAX*4,4,&SCtlp[0][0][0],NurbsS->M[0],NurbsS->M[1],GL_MAP2_VERTEX_4);
}

// NURBSȖʂ̕`(gȂ)
void Describe_BODY::DrawNurbsSurfe(NURBSS NurbsS)
{
	int j,k;
	static GLfloat	uKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	vKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	SCtlp[CTLPNUMMAX][CTLPNUMMAX][4];	// NURBS`pobt@

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,NurbsS.Dstat.Color);
	for(k=0;k<NurbsS.K[1];k++){
		for(j=0;j<NurbsS.K[0];j++){
			SCtlp[j][k][0] = NurbsS.cp[j][k].x*NurbsS.W[j][k];	// Rg[|Cgo
			SCtlp[j][k][1] = NurbsS.cp[j][k].y*NurbsS.W[j][k];
			SCtlp[j][k][2] = NurbsS.cp[j][k].z*NurbsS.W[j][k];
			SCtlp[j][k][3] = NurbsS.W[j][k];
		}
	}
	for(j=0;j<NurbsS.N[0];j++){
		uKnot[j] = NurbsS.S[j];		// umbgxNgo
	}
	for(j=0;j<NurbsS.N[1];j++){
		vKnot[j] = NurbsS.T[j];		// vmbgxNgo
	}

	// NURBSȖʂ̕`
	gluBeginSurface(NurbsSurf);
	gluNurbsSurface(NurbsSurf,NurbsS.N[0],uKnot,NurbsS.N[1],vKnot,CTLPNUMMAX*4,4,&SCtlp[0][0][0],NurbsS.M[0],NurbsS.M[1],GL_MAP2_VERTEX_4);
	gluEndSurface(NurbsSurf);

}

// Ȑ̕`
void Describe_BODY::DrawCompositeCurve(COMPC *CompC)
{
	int i;

	for(i=0;i<CompC->N;i++){
		if(CompC->DEType[i] == NURBS_CURVE){
			DrawNurbsCurve_Param((NURBSC *)CompC->pDE[i]);	// NURBSȐ
		}
		//else if(CompC->DEType[i] == CIRCLE_ARC){
		//	glDraw_CircleArc_Param((CIRA *)CompC->pDE[i]);		// ~E~
		//}
		//else if(CompC->DEType[i] == CONIC_ARC){
		//	glDraw_ConicArc_Param((CONA *)CompC->pDE[i]);		// ~Ȑ
		//}
		//else if(CompC->DEType[i] == LINE){
		//	glDraw_Line_Param((LINE_ *)CompC->pDE[i]);			// 
		//}
	}

	if(CompC->DegeFlag == KOD_FALSE)
		DrawNurbsCurve_Param(&CompC->DegeNurbs);		// kނꍇAkޗpNurbsȐgGeBeBƂĒǉ
}

// ʏ̕`
void Describe_BODY::DrawCurveOnParamSurfe(CONPS *ConpS)
{
	// 2DpgbNȐ
	if(ConpS->BType == COMPOSITE_CURVE){
		DrawCompositeCurve((COMPC *)ConpS->pB);	// Ȑ
	}
//	else if(ConpS->BType == NURBS_SURFACE){
//		glDraw_NurbsCurve(ConpS->pB);		// NURBSȐ
//	}
//	else if(ConpS->BType == CIRCLE_ARC){
//		glDraw_CircleArc(ConpS->pB);		// ~E~
//	}
//	else if(ConpS->BType == CONIC_ARC){
//		glDraw_ConicArc();					// ~Ȑ
//	}
}

// gʂ̕`
void Describe_BODY::DrawTrimdSurf(TRMS TrmS)
{
	gluBeginSurface(NurbsSurf);

	DrawTrimdNurbsSurfe(TrmS.pts);				// NURBSȖʂ̕`

	// Og(vł邱)
	gluBeginTrim(NurbsSurf);
	DrawCurveOnParamSurfe(TrmS.pTO);			// ʏ
	gluEndTrim(NurbsSurf);

	// g(vł邱)
	for(int j=0;j<TrmS.n2;j++){
		gluBeginTrim(NurbsSurf);
		DrawCurveOnParamSurfe(TrmS.pTI[j]);		// ʏ
		gluEndTrim(NurbsSurf);
	}

	gluEndSurface(NurbsSurf);

}

// 2DpgbNNURBSȐvf̕`
void Describe_BODY::DrawNurbsCurve_Param(NURBSC *NurbsC)
{
	int i;
	static GLfloat	uKnot[KNOTNUMMAX];					// NURBS`pobt@
	static GLfloat	CCtlp[CTLPNUMMAX][4];				// NURBS`pobt@

	for(i=0;i<NurbsC->K;i++){			// Rg[|Cgo
		CCtlp[i][0] = NurbsC->cp[i].x*NurbsC->W[i];
		CCtlp[i][1] = NurbsC->cp[i].y*NurbsC->W[i];
		CCtlp[i][2] = NurbsC->W[i];
	}
	for(i=0;i<NurbsC->N;i++){			// mbgxNgo
		uKnot[i] = NurbsC->T[i];
	}

	// gʂ\NURBSȐw
	gluNurbsCurve(NurbsSurf,NurbsC->N,uKnot,4,&CCtlp[0][0],NurbsC->M,GLU_MAP1_TRIM_3);

}

// BODYɊ܂܂NURBSȐSĕ`
void Describe_BODY::Draw_NurbsCurves(BODY *Body)
{
	for(int i=0;i<Body->TypeNum[_NURBSC];i++){
		glColor3f(Body->NurbsC[i].Dstat.Color[0],Body->NurbsC[i].Dstat.Color[1],Body->NurbsC[i].Dstat.Color[2]);
		if(Body->NurbsC[i].EntUseFlag == GEOMTRYELEM){				// IGESfBNg"Entity Use Flag"0̏ꍇ͎ۂ̃fvfƂĕ`悷
			DrawNurbsCurve(Body->NurbsC[i]);						// `
		}
	}
}

// BODYɊ܂܂NURBSȖʂSĕ`
void Describe_BODY::Draw_NurbsSurfaces(BODY *Body)
{
	for(int i=0;i<Body->TypeNum[_NURBSS];i++){
		if(Body->NurbsS[i].TrmdSurfFlag == KOD_TRUE)	// gʂƂNURBSȖʂo^ĂȂ
			continue;		// `悵Ȃ
		else{
			DrawNurbsSurfe(Body->NurbsS[i]);	// NURBSȖʕ`
		}
	}
}
		

// BODYɊ܂܂gʂSĕ`
void Describe_BODY::Draw_TrimSurfes(BODY *Body)
{
	for(int i=0;i<Body->TypeNum[_TRIMMED_SURFACE];i++){
		DrawTrimdSurf(Body->TrmS[i]);
	}
}


// bV̕`
void Describe_BODY::DrawMesh(MESH *mesh,int flag)
{
	//mesh->Face.setSentinel(0);
	for(int i=0;i<mesh->FaceNum;i++){
		HEface *f = (HEface *)mesh->Face.getData(i);	// iԖڂFaceXg̎̂𓾂
		//HEface *f = (HEface *)mesh->Face.getSentinelData();
		glPushName(f->index);		// t@Zbg11ɃZNVԍ蓖Ă
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,f->Dstat.Color);
		HEedge *e = f->edge;
		if(flag == KOD_TRUE)	glBegin(GL_LINE_LOOP);
		else	glBegin(GL_TRIANGLES);
		glNormal3d(f->norm.x,f->norm.y,f->norm.z);
		for(int j=0;j<f->vertnum;j++){
			glVertex3d(e->vert->cod.x,e->vert->cod.y,e->vert->cod.z);
			e = e->ne;
		}
		glEnd();
		glPopName();
		//mesh->Face.shiftSentinel(1);
	}
	glFlush();

}

// NURBS`Xe[^X̐ݒ
void Describe_BODY::SetNurbsStat()
{
	NurbsCurve = gluNewNurbsRenderer();
	gluNurbsProperty(NurbsCurve,GLU_SAMPLING_TOLERANCE,20);	
	gluNurbsCallback(NurbsCurve, GLU_ERROR, (void (CALLBACK *) (void))NURBS_Err);	// NURBS֘ÃG[̃R[obN֐o^

	NurbsSurf = gluNewNurbsRenderer();
	gluNurbsProperty(NurbsSurf,GLU_SAMPLING_TOLERANCE,20);
	gluNurbsCallback(NurbsSurf, GLU_ERROR, (void (CALLBACK *) (void))NURBS_Err);	// NURBS֘ÃG[̃R[obN֐o^
}

// NURBSȖʂ̕``ύX
void Describe_BODY::SetNurbsSProperty(GLenum prop,GLfloat val)
{
	gluNurbsProperty(NurbsSurf,prop,val);
}


// NURBSȖ/Ȑ̑ew
void Describe_BODY::SetNurbsSTolerance(GLfloat t)
{
	gluNurbsProperty(NurbsSurf,GLU_SAMPLING_TOLERANCE,t);
	gluNurbsProperty(NurbsCurve,GLU_SAMPLING_TOLERANCE,t);
}

// NURBSt@NVG[̃R[obNo^
void Describe_BODY::NURBS_Err(GLenum error_code)
{
	fprintf(stderr,"%s\n",gluErrorString(error_code));
	getchar();
	//exit(1);
}

// ~E~ʂ̕`
void Describe_BODY::DrawCircleArc()
{
	// 
}

// ~Ȑ̕`
void Describe_BODY::DrawConicArc()
{
	// 
}

// 2DpgbN~vf̕`
void Describe_BODY::DrawCircleArc_Param(CIRA *CirA)
{
	// 
}

// 2DpgbN~Ȑvf̕`
void Describe_BODY::DrawConicArc_Param(CONA *ConA)
{
	// 
}

// 2DpgbNvf̕`
void Describe_BODY::DrawLine_Param(LINE_ *Line)
{
	// 
}
