// UserSampleLq
#include "SampleFunc.h"


// Sample1: IGESt@Cǂݍ݁CBodyƂēo^
int SmpRegistBody(BODYList *BodyList,OBJECTList *ObjList)
{
	char fname[256] = "../IGES/FreeSurf.igs";	// ł̓t@C͌ߑłƂ
	IGES_PARSER Iges;					// IGESt@Cǂݍނ߂̃NXĂяo
	BODY *body = new BODY;				// ǂݍIGESf[^i[邽߂̔(BODY)p

	int flag = Iges.IGES_Parser_Main(body,fname);	// IGESf[^ǂݍŁAbodyɊi[
	if(flag == KOD_TRUE){							// ǂݍݐȂ
		Iges.Optimize4OpenGL(body);					// ǂݍIGESt@COpenGLpɍœK(K̊֐sĂ)
		SetMessage("Succeeded to read IGES file");
	}
	else{											// ǂݍ݂Ɏs
		delete body;								// mۂ[
		SetMessage("Error: fail to read IGES file");
		return KOD_ERR;								// I
	}

	body->RegistBody(BodyList,fname);		// BodyXgɓo^

	// ǂݍBODYꍇ͈ȉs
	//body->DeleteBody(BodyList);			// BodyXg͂
	//delete body;							// Bodyg̃[

	return KOD_TRUE;
}

// Sample2: w肵Bodyɑ΂AtBϊs
int SmpTransBody(BODYList *BodyList,OBJECTList *ObjList, int PickCount, double Prop[])
{
	if(!PickCount)	return KOD_ERR;		// ZNVĂȂAȂ

	OBJECT *obj = (OBJECT *)ObjList->getData(0);			// ԍŏɃZNVꂽGeBeB̏𓾂
	BODY *body = (BODY *)BodyList->getData(obj->Body);		// ԍŏɃZNVꂽBODY̎̂𓾂

	Coord rot_ax = SetCoord(0,0,1);		// ]
	double deg = 90;					// ]px
	Coord shift = SetCoord(0,0,10);		// Vtg
	Coord expand = SetCoord(2,2,2);		// g

	body->RotBody(rot_ax,deg);			// Z90x]
	body->ShiftBody(shift);				// Z10Vtg
	body->ExpandBody(expand);			// BODY2{Ɋg

	return KOD_TRUE;
}

// Sample3: Ȑw肵ŕ_𐶐
int SmpDivCurves(BODYList *BodyList,OBJECTList *ObjList, int PickCount, double Prop[])
{
	if(!PickCount)	return KOD_ERR;		// ZNVĂȂAȂ

	NURBS_Func	nfunc;					// NURBS֐WĂяo
	Coord div_pt[102];					// _̍Wli[
	double green[3] = {0,1,0};			// _\̐F()

	int divnum = (int)Prop[0];			// [U[Xe[^Xprop1𕪊Ƃēǂݍ

	// ZNV[v
	for(int i=0;i<PickCount;i++){
		OBJECT *obj = (OBJECT *)ObjList->getData(i);			// iԖڂɃZNVꂽGeBeB̏𓾂
		BODY *body = (BODY *)BodyList->getData(obj->Body);		// iԖڂɃZNVꂽBODY̎̂𓾂
		if(obj->Type == _NURBSC){								// iԖڂɃZNVꂽGeBeBNURBSȐȂ
			int ptnum = nfunc.CalcDeltaPtsOnNurbsC(&body->NurbsC[obj->Num],divnum,div_pt);		// _߂
			for(int j=0;j<ptnum;j++){
				DrawPoint(div_pt[j],1,3,green);					// _\
			}
		}
	}

	return KOD_TRUE;
}

// Sample4: Cӂ̓_̋Ȗʏ̍ŋߖT_߂
int SmpNearestPt(BODYList *BodyList,OBJECTList *ObjList, int PickCount, double Prop[])
{
	if(!PickCount)	return KOD_ERR;		// ZNVĂȂAȂ

	NURBS_Func	nfunc;					// NURBS֐WĂяo
	NURBSS *S;							// ZNVꂽȖʂւ̃|C^
	Coord Q,Q_;							// ŋߖT_i[p
	char mes[256];						// bZ[Wo͗p
	double blue[3] = {0,0,1};			// ŋߖT_\̐F()
	double red[3] = {1,0,0};			// Rg[|Cg\̐F()
	double green[3] = {0,1,0};			// ŋߖT_ƃRg[|CgȂ̐F()

	OBJECT *obj = (OBJECT *)ObjList->getData(0);		// ԍŏɃZNVꂽGeBeB̏𓾂
	BODY *body = (BODY *)BodyList->getData(obj->Body);	// ԍŏɃZNVꂽBODY̎̂𓾂

	// ZNVꂽʂgꂽNURBSȖʂCNURBSȖʂׁCNURBSȖʂ݂̂o
	// KODATUNOł́CIGESt@Cǂݍ݂̒iKőSĂ̖/NURBSȖ/ȐւƂ邽߁C
	// ̂悤3̏ɂė~ʂoƂł
	if(obj->Type == _TRIMMED_SURFACE){
		S = body->TrmS[obj->Num].pts;	// gʂ̏ꍇ́CgǑNURBSȖʂo
	}
	else if(obj->Type == _NURBSS){
		S = &body->NurbsS[obj->Num];	// NURBSȖʂ̏ꍇ͂̂܂܂̋Ȗʂւ̃|C^𓾂
	}
	else{
		return KOD_ERR;					// ZNVꂽȖʂgʂłNURBSȖʂłłȂꍇ͏I
	}

	// Cӂ̓_3p
	Coord P[3];
	P[0] = SetCoord(0,0,100);
	P[1] = SetCoord(100,50,50);
	P[2] = SetCoord(0,100,-50);

	// ߖT_𓾂
	for(int i=0;i<3;i++){
		DrawPoint(P[i],1,3,red);									// Cӓ_`
		int flag = nfunc.CalcIntersecPtNurbsPt(S,P[i],3,0.2,&Q);	// ŋߖT_Zo
		if(flag == KOD_TRUE){										// ŋߖT_
			Q_ = nfunc.CalcNurbsSCoord(S,Q.x,Q.y);					// ԍW֕ϊۑ
			DrawPoint(Q_,1,3,blue);									// ŋߖT_`
			DrawLine(Q_,P[i],1,green);								// `
			sprintf(mes,"%d:True(%lf,%lf,%lf)",i,Q_.x,Q_.y,Q_.z);
			SetMessage(mes);
		}
		else{									// ŋߖT_Ȃ
			sprintf(mes,"%d:False\n",i);		// G[bZ[WR\[ɏo	
			SetMessage(mes);
		}
	}

	return KOD_TRUE;
}

// Sample5: ȖʂUVp[^œԊuɕ_𐶐
int SmpUVDivLine(BODYList *BodyList,OBJECTList *ObjList, int PickCount, double Prop[])
{
	if(!PickCount)	return KOD_ERR;		// ZNVĂȂAȂ

	NURBS_Func	nfunc;					// NURBS֐WĂяo
	double green[3] = {0,1,0};			// _\̐F()

	OBJECT *obj = (OBJECT *)ObjList->getData(0);		// ԍŏɃZNVꂽGeBeB̏𓾂
	BODY *body = (BODY *)BodyList->getData(obj->Body);	// ԍŏɃZNVꂽBODY̎̂𓾂

	// {ł΁CSample4ɎȖʂ̃^Cvɂ򂪕Kvł邪Cȍ~Sampleł̓gʂŌߑł
	if(obj->Type != _TRIMMED_SURFACE)	return KOD_ERR;	

	NURBSS *S = body->TrmS[obj->Num].pts;				// BODYNURBSȖʂo

	int u_divnum = (int)Prop[0];						// [U[Xe[^Xprop1uƂēǂݍ
	int v_divnum = (int)Prop[1];						// [U[Xe[^Xprop2vƂēǂݍ
	double u_val = (S->U[1] - S->U[0])/u_divnum;		// pgbNԓłu𓾂
	double v_val = (S->V[1] - S->V[0])/v_divnum;		// pgbNԓłv𓾂

	// uCv̊e_ɂWl߂
	for(int i=0;i<=u_divnum;i++){
		for(int j=0;j<=v_divnum;j++){
			Coord P = nfunc.CalcNurbsSCoord(S,S->U[0]+u_val*i,S->V[0]+v_val*j);	// w肵(u,v)̍Wl߂
			DrawPoint(P,1,3,green);						// `
		}
	}

	return KOD_TRUE;
}
